freeslot("sfx_pizzah")
freeslot("sfx_pepdis")

G_AddGametype({
    name = "Pizza Time Jisk Edition",
    identifier = "PIZZATIMEJISK",
    typeoflevel = TOL_RACE,
    rules = GTR_FRIENDLY|GTR_SPAWNENEMIES|GTR_TIMELIMIT,
    intermissiontype = int_race,
    headercolor = 35,
    description = "Run away from pizzaface, in style!"
})

rawset(_G, "L_ZCollide", function(mo1,mo2)
	if mo1.z > mo2.height+mo2.z then return false end
	if mo2.z > mo1.height+mo1.z then return false end
	return true
end)

rawset(_G, "G_TicsToMTIME", function(tics)
    local minutes = tostring(G_TicsToMinutes(tics))
    local seconds = tostring(G_TicsToSeconds(tics))

    if minutes:len() < 2 then
        minutes = "0"..$
    end

    if seconds:len() < 2 then
        seconds = "0"..$
    end
    return minutes..":"..seconds
end)

local debug = false

rawset(_G, "JISK_FORCELAP", CV_RegisterVar({
	name = "jisk_forcelap",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
}))

rawset(_G, "JISK_MAXLAPS", CV_RegisterVar({
	name = "jisk_maxlaps",
	defaultvalue = "16",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
}))

rawset(_G, "JISK_PIZZATIMESTUN", CV_RegisterVar({
	name = "jisk_pizzatimestun",
	defaultvalue = "10",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
}))
rawset(_G, "JISK_FAKELAPSTUN", CV_RegisterVar({
	name = "jisk_fakelapstun",
	defaultvalue = "3",
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
}))

rawset(_G, "JISK_TPINV", CV_RegisterVar({
	name = "jisk_tpinv",
	defaultvalue = "3", -- IN SECONDS
	flags = CV_NETVAR,
	PossibleValue = CV_Unsigned, 
}))

rawset(_G, "JISK_PIZZALAUGH", CV_RegisterVar({ -- Whenever the pizzaface laugh plays when pizzatime starts.
	name = "jisk_pizzalaugh",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff, 
}))

rawset(_G, "JISK_PIZZATIME", 0)

local spawn_location = 
{x = 0, y = 0, z = 0, angle = 0} -- where the sign is at the start of the map
local spawn_location_atdefault = 
(spawn_location.x == 0 and spawn_location.y == 0 and spawn_location.z == 0 and spawn_location.angle == 0) -- returns true if at the defaults

local end_location = 
{x = 0, y = 0, z = 0, angle = 0} -- where the sign originally was in the map placement
local end_location_atdefault = 
(end_location.x == 0 and end_location.y == 0 and end_location.z == 0 and end_location.angle == 0) -- returns true if at the defaults

rawset(_G, "JISK_LAPS", 0)
rawset(_G, "JISK_QUITTING", false)
local endsector = nil

rawset(_G, "JISK_COUNT", do
	local playerCount = 0
	local exitingCount = 0
	local pizzaCount = 0
	for player in players.iterate
		if player.valid
			if player.pizzaface then
				pizzaCount = $+1
			end
			if player.exiting or player.spectator or player.pizzaface
				exitingCount = $+1
			end
		end
		playerCount = $+1
	end
	return exitingCount,playerCount, pizzaCount
end)

addHook("NetVars", function(net)
    JISK_PIZZATIME = net($)
    spawn_location = net($)
	end_location = net($)
    endsector = net($)
	JISK_LAPS = net($)
	JISK_QUITTING = net($)
end)


local function InitMap()
	JISK_PIZZATIME = false -- doesn't matter what gamemode it is, just make it false all the time.
    spawn_location = {x = 0, y = 0, z = 0}
    endsector = nil
	JISK_LAPS = 0
	JISK_QUITTING = false
end

local function InitMap2()
    if gametype ~= GT_PIZZATIMEJISK then return end
    for map in mapthings.iterate do
        if map.type == 1 then
            spawn_location.x = map.x
            spawn_location.y = map.y
            spawn_location.z = map.z
            spawn_location.angle = map.angle
            if debug then
                print(":spawn_location:")
                print("x: "..spawn_location.x, "y: "..spawn_location.y, "z: "..spawn_location.z)
            end
        end

        if map.type == 501 then
            end_location.x = map.x
            end_location.y = map.y
            end_location.z = map.z
            end_location.angle = map.angle
            if debug then
                print(":end_location:")
                print("x: "..end_location.x, "y: "..end_location.y, "z: "..enf_location.z)
            end
        end
    end
	for player in players.iterate() do
		player.pizzaface = false
		player.pizzamask = nil
		player.stuntime = 0
		player.spectator = false
		player.lapsdid = 0
		player.laptime = 0
	end
end


addHook("MapChange", InitMap)

addHook("MapLoad", InitMap)
addHook("MapLoad", InitMap2)

    

-- doesnt actually trigger or increment lap, just tps you
local function LapTP(player)
	player.exiting = 0
	P_SetOrigin(player.mo, end_location.x*FRACUNIT,end_location.y*FRACUNIT, end_location.z*FRACUNIT)
	player.mo.angle = end_location.angle - ANGLE_90
	player.powers[pw_invulnerability] = JISK_TPINV.value*TICRATE -- converts to seconds
end

local function StartNewLap(mobj,line)
	if mobj.player.exiting then return end
	
	if not mobj.player.pizzaface then
		JISK_LAPS = $ + 1
		chatprint("\x82\*LAP ".. JISK_LAPS.. " ("..mobj.player.name.." "..G_TicsToMTIME(mobj.player.laptime)..")", true)
		mobj.player.laptime = 0
		if JISK_FORCELAP.value then 
			LapTP(mobj.player)
		else
			P_DoPlayerExit(mobj.player)
		end
		
		if mobj.player.lapsdid ~= nil  then
			mobj.player.lapsdid = $ + 1
			P_AddPlayerScore(mobj.player, mobj.player.lapsdid*1024)
		end
		/* old stun code
		for pizzahead in players.iterate() do
			if pizzahead.pizzaface then
				pizzahead.stuntime = TICRATE*3
			end
		end
		*/
	else -- FAKE LAP -- 
		mobj.player.stuntime = TICRATE*JISK_FAKELAPSTUN.value
		P_SetOrigin(mobj, end_location.x*FRACUNIT,end_location.y*FRACUNIT, end_location.z*FRACUNIT)
		mobj.angle = end_location.angle - ANGLE_90
	end
end


local function PizzaTimeTrigger(mobj,line)
	if not (JISK_PIZZATIME and spawn_location_atdefault) then
		JISK_PIZZATIME = true
		
		local thesign = P_SpawnMobj(0,0,0, MT_SIGN)
		P_SetOrigin(thesign, spawn_location.x*FRACUNIT, spawn_location.y*FRACUNIT, spawn_location.z*FRACUNIT)
		thesign.angle = spawn_location.angle
		
		if thesign.subsector then
			endsector = thesign.subsector.sector
		end
		for player in players.iterate() do
			local pmo = player.mo
			P_SetOrigin(pmo, end_location.x*FRACUNIT,end_location.y*FRACUNIT, end_location.z*FRACUNIT)
			pmo.angle = end_location.angle - ANGLE_90
		end     
		
		if JISK_PIZZALAUGH.value then
			S_StartSound(nil, sfx_pizzah)
		end
		
		--hit the player that touched the line with these variables
		local exitingCount, playerCount = JISK_COUNT()
		
		if playerCount > 1 then
			mobj.player.pizzaface = true
			mobj.player.stuntime = TICRATE*JISK_PIZZATIMESTUN.value
		end
		
	end
end



addHook("MobjLineCollide", function(mobj, line)
    if gametype ~= GT_PIZZATIMEJISK then return end
	
	if mobj.player.spectator then return end -- no trolling.
	
    if debug then
        for a=1,2 do
            local front = a == 1
            local back = a == 2
            if front then
                print(":front:")
            elseif back then
                print(":back:")
            end
            for b=1,4 do
                if front then
                    print(">frontspecial ".. b)
                    print(GetSecSpecial(line.frontsector.special, b))
                elseif back then
                    print(">backspecial".. b)
                    print(GetSecSpecial(line.backsector.special, b))
                end
            end
        end
    end

    -- Line Check at End
    if (line.frontsector and GetSecSpecial(line.frontsector.special, 4) == 2) 
    or (line.backsector and GetSecSpecial(line.backsector.special, 4) == 2) then 
		PizzaTimeTrigger(mobj,line)
    end

    -- Sign at start check.
    if (line.backsector and line.backsector == endsector)
    or (line.frontsector and line.frontsector == endsector) then 
		StartNewLap(mobj,line)
    end
end, MT_PLAYER)

-- simple midgame joining blocker.
addHook("PlayerSpawn", function(player)
	player.lapsdid = $ or 0
	player.laptime = $ or 0 
	if player.realmo and player.realmo.valid then
		if player.pizzaface then
			return
		end
		if JISK_PIZZATIME and leveltime then
			player.spectator = true
		end
	end
end)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid then
		if player.exiting and (player.cmd.buttons & BT_ATTACK) and not JISK_QUITTING then 
			LapTP(player)
		end
		
		if player.laptime ~= nil and JISK_PIZZATIME then
			player.laptime = $ + 1
		end
	end
end)

addHook("MobjCollide", function(mo1, mo2) -- taken from the original since barely anything needs to be changed
	if not JISK_PIZZATIME then return end
	if not mo1.player then return end
	if not mo2.player or (mo2.player and not mo2.player.pizzaface) then return end -- only continue if mo2 is pizzaface
	if mo2.player.stuntime then return end
	if mo1.player.exiting then return end
	if mo1.player.powers[pw_invulnerability] then return end
	if mo1.player.pizzaface then return end -- lets not tag our buddies!!
	if not L_ZCollide(mo1,mo2) then return end
	mo1.player.spectator = true
	chatprint("\x82*"..mo1.player.name.." has died.")
	if P_RandomChance(FRACUNIT/4) then
		S_StartSound(nil, sfx_pepdis)
	end
end, MT_PLAYER)

--THE BADNIKS ARENT PIZZAHEAD'S ENEMY
addHook("ShouldDamage", function(target, inflictor)
	if target.valid and target.player and target.player.pizzaface and inflictor and inflictor.valid and (inflictor.flags & MF_ENEMY) then
		return false
	end
end)

addHook("HUD", function(v,player)
	local exitingCount, playerCount = JISK_COUNT()
	
	if player.stuntime then
		v.drawString(160, 100, "You will be unfrozen in: "..player.stuntime/TICRATE.. " seconds.", V_TRANSLUCENT|V_SNAPTOBOTTOM|V_PERPLAYER, "center")
		
	end
	if JISK_PIZZATIME then
		if not JISK_MAXLAPS.value then
			v.drawString(160, 0, "\x82\* LAPS: "..JISK_LAPS.." *", V_TRANSLUCENT|V_PERPLAYER|V_SNAPTOTOP, "center")
		else
			v.drawString(160, 0, "\x82\* LAPS: "..JISK_LAPS.." / "..JISK_MAXLAPS.value.." *", V_TRANSLUCENT|V_PERPLAYER|V_SNAPTOTOP, "center")
		end
		
		if (not player.pizzaface) and (player.exiting) then
			v.drawString(160, 120, "\x85\* Press FIRE to try a new lap! *", V_TRANSLUCENT|V_SNAPTOBOTTOM|V_PERPLAYER, "center")
		end
		
		if (playerCount == 1) then
			v.drawString(160, 8, "\x84\* PRACTICE MODE *", V_TRANSLUCENT|V_SNAPTOTOP|V_PERPLAYER, "center")
		end
	end
end,"game")

/* unused sign animation, i thought the sign would appear at the end if allowexit was off lol
addHook("MobjThinker", function(mobj)
    if mobj.triggered_end then
        if not mobj.triggered_end2 then --triggered_end2 is a toggle so that we can safely set the fues
            mobj.triggered_end2 = true
            mobj.fuse = 20*FU
        end
        mobj.angle = $ + ANG15
        P_SetObjectMomZ(mobj, 2*FU)
    end
end, MT_SIGN)

addHook("MobjFuse", function(mobj)
    A_RingExplode(mobj)
end, MT_SIGN)
*/