freeslot("MT_PIZZAMASK", "S_PIZZAFACE", "SPR_PZAT")

mobjinfo[MT_PIZZAMASK] = {
	doomednum = -1,
	spawnstate = S_PIZZAFACE,
	spawnhealth = 1000,
	deathstate = S_NULL,
	radius = 16*FU,
	height = 48*FU,
}


states[S_PIZZAFACE] = {
    sprite = SPR_PZAT,
    frame = FF_ANIMATE|A,
    tics = -1,
    var1 = 15,
    var2 = 2,
    nextstate = SPR_PZAT
}

--Pizza Face Thinker
addHook("PlayerThink", function(player)
	if gametype ~= GT_PIZZATIMEJISK then return end
	if player.realmo and player.realmo.valid and player.pizzaface and leveltime then
		P_SetScale(player.realmo, 2*FU)
		player.realmo.flags2 = $|MF2_DONTDRAW -- invisible so that the pizza mask can draw over.
		player.spectator = false -- dont give up! dont spectate as pizzaface! (theres another check when spawning so idk 
		
		if player.stuntime then -- player freeze decrement (mainly for pizza faces)
			player.stuntime = $ - 1
			player.pflags = $|PF_FULLSTASIS
		end
		
		if not player.pizzamask or not player.pizzamask.valid then
			player.pizzamask = P_SpawnMobj(player.realmo.x,player.realmo.y,player.realmo.z,MT_PIZZAMASK)
			player.pizzamask.targetplayer = player --dream reference
			player.pizzamask.scale = FU/2
		end
		
		/*
		if not p.mo.colorized or p.mo.color != SKINCOLOR_ORANGE
			p.mo.color = SKINCOLOR_ORANGE
			p.mo.colorized = true		
		end
		*/
	end
end)

-- Pizza Mask Thinker
addHook("MobjThinker", function(mobj)
	if gametype ~= GT_PIZZATIMEJISK then return end
	if mobj.targetplayer and mobj.targetplayer.mo and mobj.targetplayer.mo.valid then
		local targetplayer = mobj.targetplayer
		P_MoveOrigin(mobj, targetplayer.mo.x, targetplayer.mo.y, targetplayer.mo.z)
	end
end, MT_PIZZAMASK)


COM_AddCommand("makepizza", function(player, arg)
	if gametype ~= GT_PIZZATIMEJISK then
		CONS_Printf(player, "Command must be ran in the Pizza Time Jisk Edition mode.")
		return
	end
	if tonumber(arg) == nil then
		CONS_Printf(player, "arg1 must be a number.")
		return
	end
	if not arg then
		CONS_Printf(player, "makepizza <playernum>")
		return
	end
	
	if players[tonumber(arg)] then
		local targetplayer = players[tonumber(arg)]
		targetplayer.pizzaface = true
	else
		CONS_Printf(player, "Player does not exist")
	end
end,1)
